% stability effects not yet included
function [Kc]=Kc_above_canopy_HF2008(z,hcanopy,ustar,beta,Scc,St,Leaf_Vol,Cd,LMONIN)
% z - height, hcanopy - canopy heigh, ustar - friction velo at hcanopy,
% beta -ustar/U(h) , Scc - Schmidt number, r - resistance at leaf level, Leaf_Vol
% - Leaf area index (total leaf are in canopy/volume), St - Leaf level
% Stanton number, Cd - Leaf level drag coefficient
% according to formula of Harman and Finnigan, 2008

if nargin < 9
    LMONIN=100000000;
end


carman=0.4;
Lc=1/Leaf_Vol/Cd;
lscale=2*beta^3*Lc;
d1=Lc*beta^2;
d=hcanopy-d1;

if z>50
    lll=1;
end
[fic0,dficdz0]=fih_stab((hcanopy-d),LMONIN);
%fic0=1;
%dficdz0=0;
ficc0=carman*Scc/2/beta/fic0;

f=0.5*((1+4*St*Scc)^0.5-1);

C2=carman*Scc*(2+f-2*beta^2*Lc*dficdz0/fic0)/(2*beta*fic0-carman*Scc);
C1=(1-ficc0)*exp(0.5*C2);

if C2<0
%    err=-1;
%    Kc=[];
%    return;
end
fic1=1-C1*exp(-C2*beta*(z-d)/lscale);

[fic]=fih_stab((z-d),LMONIN);

Kc=carman*ustar*(z-d)/fic1/fic;

return;
% calculated as for neutral stratif. all changes marked with '_' after
% usual name
ficc0_=carman*Scc/2/beta;

C2_=carman*Scc*(2+f)/(2*beta-carman*Scc);
C1_=(1-ficc0_)*exp(0.5*C2_);

if C2<0
%    C2=0;
end
fic1_=1-C1_*exp(-C2_*beta*(z-d)/lscale);

Kc_=carman*ustar*(z-d)/fic1_;
%Kc=Kc_;
return;