% beta value should include stability effect
function [Km,err,d,fim,fim1]=Km_above_canopy_HF2008(z,hcanopy,ustar,beta,Leaf_Vol,Cd,LMONIN)
% z - height, hcanopy - canopy heigh, ustar - friction velo at hcanopy,
% beta -ustar/U(h) , Leaf_Vol - 
% - Leaf area index (total leaf are in canopy/volume), St - Leaf level
% Stanton number, Cd - Leaf level drag coefficient
% according to formula of Harman and Finnigan, 2008

if nargin < 7
    LMONIN=100000000;
end
err=false;

carman=0.4;
Lc=1/Leaf_Vol/Cd;
lscale=2*beta^3*Lc;
d1=Lc*beta^2;
%if(d1>0.25*hcanopy)
%    d1=0.25*hcanopy;
%end
d=hcanopy-d1;

[fim0,dfimdz0]=fim_stab((hcanopy-d),LMONIN);

fimm0=carman/2/beta/fim0;

C2m=carman*(3-2*(beta^2)*Lc*dfimdz0/fim0)/(2*beta*fim0-carman);
%C1m=(1-fimm0)*exp(0.5*C2m);

if C2m<0
    err=true;
    Km=[];
    'C2m<0'
    %pause;
    return;
end
%fim1=1-C1m*exp(-C2m*beta*(z-d)/lscale);
fim1=1-(1-fimm0)*exp(0.5*C2m-C2m*beta*(z-d)/lscale);

[fim]=fim_stab((z-d),LMONIN);

Km=carman*ustar*(z-d)/fim1/fim;
return;
% calculated as for neutral stratif. all changes marked with '_' after
% usual name
fimm0_=carman/2/beta;

C2m_=carman*(3)/(2*beta-carman);
C1m_=(1-fimm0_)*exp(0.5*C2m_);

if C2m_<0
    'C2m_<0'
    pause;
%    C2=0;
end
fim1_=1-C1m_*exp(-C2m_*beta*(z-d)/lscale);

Km_=carman*ustar*(z-d)/fim1_;
%Kc=Kc_;
return;