function [Sc]=Sc_on_MOL(Mol)
% returns Schmidt number depending on Monin Obukhov Length as follows from
% paper of Harman and Finnigan, 2008. Scalar Concentration Profiles...//
% Boundary Layer Meteorology, Figures 6-9

L=[20,60,70,110,220,470,1000];
Sneg=[0.1,0.2,0.23,0.28,0.38,0.43,0.5];
Spos=[0.8,0.8,0.8,0.8,0.75,0.6,0.5];

if Mol<0
    S=Sneg;
else
    S=Spos;
end
L1=abs(Mol);

if L1<=L(1)
    Sc=S(1);
    return;
elseif L1>=L(7)
    Sc=S(7);
    return;
end

for i=1:7
    if L(i)>L1
        Sc=S(i)*(L1-L(i-1))+S(i-1)*(L(i)-L1);
        Sc=Sc/(L(i)-L(i-1));
        return;
    end
        
end

end