function [canopy_parms, measure_parms, model_parms, src_parms, selection_parms,...
    c14_parms,skips,meteo_parms] = create_input_new()
% Initializes main input parameters
global cheight St beta Scc_n Sg pla ext_coeff value_boreal value_broadleaf value_mixed value_agri value_calc_an 
global value_user_input LAI value_uniform value_height_dep ref_height wind_speed
global value_empirical value_HF08 value_modified_HF08 dz value_output_grid value_output_layers
global layers_CO2 Percent_CO2_layers1 MO_length C14_release C14_ubc value_uniform_CO2 value_height_dep_CO2 background gross_photosynt net_resp
global layers LAI_layers1 beta1 Csigma C1 


canopy_parms.hcanopy=cheight;%14.0;
hcanopy=canopy_parms.hcanopy;
canopy_parms.betan=beta%0.285;% will be redefined
canopy_parms.Scc=0.55;%Schmidt number
canopy_parms.Scc_neutr=Scc_n%0.55;% used only when selection_parms.Scc_model=true
canopy_parms.Scc_grad=Sg%?????%0.0;% used only when selection_parms.Scc_model=true
canopy_parms.St=St%0.1;%Stanton number
canopy_parms.Cd=0.25;
%canopy_parms.h_over_Lc=0.25;
if pla==0
canopy_parms.Leaf_Vol=0.050775213855146;%0.078;
else
    canopy_parms.Leaf_Vol=pla;%0.051;
end
if (value_calc_an==1)
canopy_parms.LAI=canopy_parms.Leaf_Vol*canopy_parms.hcanopy*(3.14)^2/2 % typical for Norunda
else
    canopy_parms.LAI=LAI;
end
canopy_parms.dsp=0.2*canopy_parms.hcanopy;%3.8;% displacement hgt from Molder's data
canopy_parms.z0=0.03;
canopy_parms.extinction=ext_coeff;%0.18;
canopy_parms.zmin=6;% bottom height of crone; photosynthesis and PAR decay is assumed to occur only between zmin an hcanopy
canopy_parms.NPP=gross_photosynt-net_resp; % [g C/m2/yr] net primary production: used only when concentration flux measurements are not available;
% chosen to approximately correspond to net concentration flux in summer 2004 (-2.4 umol/m2s)
canopy_parms.NEE=-canopy_parms.NPP*(44/12)*(1/3600/24/365)*(1/44)*(10^6);%%??- convert to: >gCO2/m2yr>gCO2/m2/s>molCO2/m2s>umolCO2/m2/s
canopy_parms

%%
%canopy_parms.Leaf_Vol=canopy_parms.h_over_Lc/canopy_parms.Cd/canopy_parms.hcanopy;% Total (at height hcanopy) Leaf area per unit volume
cnames{1}='CO2042';cnames{2}='CO2084';cnames{3}='CO2168';cnames{4}='CO2336';
cnames{5}='CO2504';cnames{6}='CO2672';
zmast=ref_height;%[4.2 8.4 16.8 33.6 50.4 67.2];
measure_parms.cnames=cnames;

unames{1}='U042-nomeas';
unames{2}='U084';unames{3}='U168';unames{4}='U336';
unames{5}='U504-nomeas';% fictive measurement
unames{6}='U672';
measure_parms.unames=unames;

measure_parms.zmast=zmast;
measure_parms.Lev_up=1;% measurement level which is used to specify upper boundary conditions

model_parms.beta1=beta1;%1.3;
model_parms.c1_Tlscale=C1;%4.86;
model_parms.c2_Tlscale=0.3;
model_parms.dz=dz;%0.1;
%IK2019 model_parms.bottom=cheight/10;%1.0;% lowest model level in meters
model_parms.bottom=1.0;% lowest model level in meters

model_parms.carman=0.4;
model_parms.sw_over_ust=Csigma;
model_parms
%src_parms.heights=[4,9.0,11.5,13,hcanopy];% for the case of selection_parms.respiration=false
%src_parms.parts=[0.11,0.25,0.11,0.14,0.39];%;
%src_parms.photo_heights=[8,10.0,13,14,hcanopy];%[18.0,20,22,hcanopy];% for the case of selection_parms.respiration=true
%src_parms.photo_parts=photosyn_fractions(canopy_parms,src_parms);
%src_parms.photo_parts=[0.23,0.35,0.2,0.13,0.09];%[0.0,0.1,0.3,0.6];% heights and parts for partitioning of photosynthesis flux
%????   uniform?????
if (value_height_dep_CO2)
src_parms.resp_heights=layers_CO2;%[0.1,7.0,hcanopy];% heights and parts for partitioning of respiration flux
src_parms.resp_parts=Percent_CO2_layers1/100;
end%[0.5,0.25,0.25];
if (value_uniform_CO2)
    src_parms.resp_heights=hcanopy;
    src_parms.resp_parts=1;
end
%src_parms.resp_heights=[hcanopy];% heights and parts for partitioning of respiration flux
%src_parms.resp_parts=[1.0];

selection_parms.user=true;%if this parameter is set true than meteo and concentration flux data are not read from measurements but set in this file ()
selection_parms.MOL_neutral=500;
selection_parms.MOL_thresh_left=500;
selection_parms.MOL_thresh_right=500;
selection_parms.day=true;
selection_parms.thresh_ust=0.1;
selection_parms.absthresh_fc=0.1;
selection_parms.cnearon=false;
selection_parms.cfaron=true;
selection_parms.respiration=true;
selection_parms.use_turb_meas=true;% whether to use ustar and sigw(h) 
if (value_empirical==0)
selection_parms.HF08_inside=true;
else
    selection_parms.HF08_inside=false
end;% if relationships of Harman and Finnigan, 2008, BLM to be used inside canopy

selection_parms.HF08_numer=value_modified_HF08;
%false;
selection_parms.HF08_modif=false;
selection_parms.Scc_model=true;
selection_parms.storage_flux=false;
%or parameterize them as ~U(h)
selection_parms.Ecolego_inside=false;
selection_parms.ifc14=true;
selection_parms


c14_parms.ubc=C14_ubc; %IK2019
c14_parms.Bq_flux=C14_release/365/24/3600;%convert from Bq/m2/yr to  Bq/m2/s]
if c14_parms.ubc~=0
    %c14_parms.Bq_flux=0;
end
c14_parms.Bq2micromol=0.44*0.000001;% 140 PBq = 840 kg - total C14 inventory on Earth /14*1E-3 kg/mol
c14_parms.micromol_flux=c14_parms.Bq2micromol*c14_parms.Bq_flux;% micromol/m2/s flux
c14_parms.microgram_flux=c14_parms.micromol_flux*14;
c14_parms.flux=c14_parms.micromol_flux*22.4/1000;%micromol/mol/s flux



skips.last_year=2009;

i=1;% skip all months except from 10 May to end of August
skip{i}.month=1;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skip{i}.month=2;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skip{i}.month=3;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skip{i}.month=4;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skip{i}.month=5;skip{i}.start_day=1;skip{i}.end_day=9;i=i+1;
skip{i}.month=9;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skip{i}.month=10;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skip{i}.month=11;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skip{i}.month=12;skip{i}.start_day=1;skip{i}.end_day=31;i=i+1;
skips.skip=skip;


meteo_parms.date=[2004;5;15;12];
meteo_parms.MOL=MO_length;%1000;
meteo_parms.uref=wind_speed;%10.0;
meteo_parms.ta=11.8;%average for June
meteo_parms.tsoil=8.4;
meteo_parms.co2ref=background;%400;%umol/mol

meteo_parms
end

function [photo_parts]=photosyn_fractions(canopy_parms,src_parms)
hcanopy=canopy_parms.hcanopy;
LAI=canopy_parms.LAI;
Ke=canopy_parms.extinction;
zmin=canopy_parms.zmin;
dcanopy=hcanopy-zmin;

photo_heights=src_parms.photo_heights;%[4,9.0,11.5,13,hcanopy];
syms z f;
f=exp(-Ke*LAI*((hcanopy-z)/dcanopy));
denom=eval(int(f,zmin,hcanopy));

if photo_heights(1)>zmin
   photo_parts(1)=eval(int(f,zmin,photo_heights(1)))/denom;
else
    photo_parts(1)=0;
end
nn=size(photo_heights,2);
for i=2:nn
    if photo_heights(i)>zmin
        photo_parts(i)=eval(int(f,max(zmin,photo_heights(i-1)),photo_heights(i)))/denom;
    else
        photo_parts(i)=0;
    end
        
end
summ=sum(photo_parts);
if abs(1-summ)>0.01
    'sum of photo_parts='
    summ
    pause;
end
return;
end


