function [ fi, dfidz ] = fim_stab(z,Mol)
% returns value of similarity function for given ksi
% 'arya' parameterization is taken from book of Arya, 2004. Introduction to
% Micrometeorology. 2nd Edition. Academic Press. page 219, formula (11.9)
businger=false;
arya=true;

ksi=z/Mol;

if businger==true
    alfa=0.74;
    if ksi > 0.001
        fi=alfa+4.7*ksi;
    elseif ksi < -0.001
        fi=alfa/(1-9*ksi)^0.5;
    
    else
        fi=alfa;
    end
elseif arya==true
    if ksi > 0.001
        fi=1+5*ksi;
        dfidz=5/Mol;
    elseif ksi < -0.001
        fi=1/(1-15*ksi)^0.25;
        dfidz=0.25*15/Mol/((1-15*ksi)^1.25);
    else
        fi=1;
        dfidz=0;
    end
    
end
return;
end