function [variable,line]=get_variable(pathname,fname,varname,date,line)
% get variable from commma separated data file; column names are stored in
% header.txt; if line number is given, it is used; otherwise it is found
% from the {date}
fullname=strcat(pathname,'/',fname);
M=csvread(fullname);

if nargin<5
    line=find_row(M,date);
    if line==0
        'error: appropriate date not found in file'
        fullfname
        date
        pause;
    end
else % line is given
    if date~=datenum(M(line,1),M(line,2),M(line,3),M(line,4),M(line,5),M(line,6))
        'error line number for date'
        date 
        'in file'
        fullname
        pause;
    end
end

[col]=process_header(pathname,varname);

if col==0
   'error: appropriate column not found in header for variable'
    varname
    pathname
    pause;
end

variable=M(line,col);
return;

end




function [row]=find_row(M,date)

curdate=datenum(M(1,1),M(1,2),M(1,3),M(1,4),M(1,5),M(1,6));
if curdate>date
    row=0;% this is error
    return;
end
for i=1:size(M,1)
    curdate=datenum(M(i,1),M(i,2),M(i,3),M(i,4),M(i,5),M(i,6));
    if curdate==date 
        row=i;
        return;
    end
end

row=0;% this is error
return;
end


