function [Sfric,a]=initialize_Sfric(laioption,canopy_parms,zgrid)
% uses data of Moren, 2000. Trees, 14, 384-397, Fig.6
addz=3;
N=size(zgrid,2);

meana=canopy_parms.Leaf_Vol;
hcanopy=canopy_parms.hcanopy;

itop=0;
for i=1:N
    
    if zgrid(i)<=hcanopy && itop==0
        itop=i;
    end

    if laioption==1
        zz=zgrid(i)-addz;
        %a(i)=moren_mixed(zz)
        a(i)=moren_mixed_relh(zgrid(i)/hcanopy);
    elseif laioption==2
        addz=canopy_parms.hcanopy-23.; %
        zz=zgrid(i)-addz;
        a(i)=moren_mixed(zz);
    elseif laioption==3
        zz=zgrid(i);
        a(i)=twolayer(zz,hcanopy,0.5,0.75);
    elseif laioption==4
        addz=canopy_parms.hcanopy-23.; %
        zz=zgrid(i)-addz;
        a(i)=moren_pine(zz);
        
    end

        
end
    meana0=sum(a)*(zgrid(itop)-zgrid(itop+1))/hcanopy;
    a=a*(meana/meana0);% correct for desirab;e normal projection of area
    Sfric=a*canopy_parms.Cd;
    return;
    
end
function [a]=moren_mixed_relh(zrel)


    if(zrel<0.065)
        a=0.03;
    elseif(zrel<0.109)
        a=0.03;
    elseif(zrel<0.152)
        a=0.08;
    elseif(zrel<0.196)
        a=0.12;
    elseif(zrel<0.239)
        a=0.16;
    elseif(zrel<0.283)
        a=0.18;
    elseif(zrel<0.326)
        a=0.2;
    elseif(zrel<0.370)
        a=0.21;
    elseif(zrel<0.413)
        a=0.215;
    elseif(zrel<0.457)
        a=0.225;
    elseif(zrel<0.5)
        a=0.26;
    elseif(zrel<0.543)
        a=0.325;
    elseif(zrel<0.587)
        a=0.4;
    elseif(zrel<0.630)
        a=0.46;
    elseif(zrel<0.674)
        a=0.53;
    elseif(zrel<0.717)
        a=0.55;
    elseif(zrel<0.761)
        a=0.57;
    elseif(zrel<0.804)
        a=0.42;
    elseif(zrel<0.848)
        a=0.22;
    elseif(zrel<0.891)
        a=0.25;
    elseif(zrel<0.935)
        a=0.1;
    elseif(zrel<0.978)
        a=0.05;
    elseif(zrel<1)
        a=0.05;
    else
        a=0.0;
    end

end
function [a]=moren_mixed(zz)
    if(zz<1.5)
        a=0.002;
    elseif(zz<2.5)
        a=0.01;
    elseif(zz<3.5)
        a=0.08;
    elseif(zz<4.5)
        a=0.12;
    elseif(zz<5.5)
        a=0.16;
    elseif(zz<6.5)
        a=0.18;
    elseif(zz<7.5)
        a=0.2;
    elseif(zz<8.5)
        a=0.21;
    elseif(zz<9.5)
        a=0.215;
    elseif(zz<10.5)
        a=0.225;
    elseif(zz<11.5)
        a=0.26;
    elseif(zz<12.5)
        a=0.325;
    elseif(zz<13.5)
        a=0.4;
    elseif(zz<14.5)
        a=0.46;
    elseif(zz<15.5)
        a=0.53;
    elseif(zz<16.5)
        a=0.55;
    elseif(zz<17.5)
        a=0.57;
    elseif(zz<18.5)
        a=0.42;
    elseif(zz<19.5)
        a=0.22;
    elseif(zz<20.5)
        a=0.25;
    elseif(zz<21.5)
        a=0.1;
    elseif(zz<22.5)
        a=0.05;
    elseif(zz<23.5)
        a=0.05;
    else
        a=0.0;
    end

end

function [a]=moren_pine(zz)
   if zz<9.5
       a=0;
   elseif zz<10.5
       a=0.015;
   elseif zz<11.5
       a=0.065;
   elseif zz<12.5
       a=0.11;
   elseif zz<13.5
       a=0.18;
   elseif zz<14.5
       a=0.23;
   elseif zz<15.5
       a=0.265;
   elseif zz<16.5
       a=0.25;
   elseif zz<17.5
       a=0.18;
   elseif zz<18.5
       a=0.07;
   elseif zz<=19.5
       a=0.015;
   else
       a=0;
   end
end


function [a]=twolayer(zz,hcanopy,frachup,fraccup)
%frachup - fraction of upper canopy height  in which (relative to hcanopy)
% fraccup - fraction of leaves in upper canopy height (relative to total LAI)
    if(zz<(1-frachup)*hcanopy)
        a=(1-fraccup)/(1-frachup);
    else
        a=fraccup/frachup;
    end
end

