function [c14,k_on_z]=integr_c14(zgrid,tlscale,sigw,fluxes,cref,canopy_parms,ust,mol,selection_parms,...
    c14_parms,cfar)
% integrates 'far field' concentration according to diffusion equation;
 % {k_on_z} - structure containing vertical profile of the diffusion
 % coefficient
c14(1)=cref;
for i=2:size(zgrid,2)
    dz=zgrid(i-1)-zgrid(i);    
    ki1=tlscale(i)*sigw(i)^2;
    ki2=tlscale(i-1)*sigw(i-1)^2;
    hcanopy=canopy_parms.hcanopy;
   if i==size(zgrid,2)-1
       lps=0;
   end
    if selection_parms.HF08_inside==true
        %follow Harman & Finnigan inside canopy if necessary
        Leaf_Vol=canopy_parms.Leaf_Vol;
        Cd=canopy_parms.Cd;
        Lc=1/Leaf_Vol/Cd;
        betan=canopy_parms.betan;
        
        Scc=canopy_parms.Scc;
        mult=2*betan^3*Lc*ust/Scc;
        ki1=mult*exp((zgrid(i)-hcanopy)/2/betan^2/Lc);
        ki2=mult*exp((zgrid(i-1)-hcanopy)/2/betan^2/Lc);
    end
    kdif=2*ki1*ki2/(ki1+ki2);
    if i==100
        llll=1;
    end
    if nargin>5 
        hcanopy=canopy_parms.hcanopy;
        if zgrid(i)>hcanopy && zgrid(i+1)<=hcanopy
            hcanopy=canopy_parms.hcanopy;
        end
        if zgrid(i)>hcanopy
            betan=canopy_parms.betan;
            Scc=canopy_parms.Scc;
            St=canopy_parms.St;
            Leaf_Vol=canopy_parms.Leaf_Vol;
            Cd=canopy_parms.Cd;
            kdif=Kc_above_canopy_HF2008(0.5*(zgrid(i)+zgrid(i-1)),hcanopy,ust,betan,Scc,St,Leaf_Vol,Cd,mol);
        end
    end
    flux=0.5*(fluxes(i)+fluxes(i-1));

    fii=0.5*(cfar(i)+cfar(i-1));
    K_dz=(kdif/dz);
    F_fi=0.5*flux/fii;
    c14(i)=((K_dz+F_fi)*c14(i-1)+c14_parms.flux)/(K_dz-F_fi);
    
    if nargout > 1
        k_on_z.k(i-1)=kdif;
        k_on_z.z(i-1)=0.5*(zgrid(i)+zgrid(i-1));
    end
    continue;
end

return;
end