function main_co2_sonia(path_to_data)
global runname beta1 molleft molright Scc ifday nestedrun HF08_inside ...
betan_ sw_ust;
global carm_ hcan_ Lc_;
global net_resp
global Scc_neutr Scc_grad;
global allmae;
global output_filename

% calculations of co2 profiles for conditions of Norunda site for night
% time and neutral conditions or vice versa

if exist('nestedrun','var')==false
    nestedrun=false;
elseif nestedrun~=true
    nestedrun=false;
end

if nargin==0
%    path_to_data='D:\Users\ik\WORK\2016_C14\Finnish_SMEAR\2004';
    outname='cfar-70m.mat';
end
[ canopy_parms, measure_parms, model_parms, src_parms, selection_parms,...
    c14_parms,skips,meteo_parms] = create_input_new();
if selection_parms.user~=true
    'Error from main_co2_svat: this subroutine is intended for running on user-defined data,'
    'not measurement data'
    pause;
end


if selection_parms.HF08_modif==true
    carm_=model_parms.carman;
    hcan_=canopy_parms.hcanopy;
    Lc_=1/canopy_parms.Leaf_Vol/canopy_parms.Cd;
end
if nestedrun==true
    selection_parms.day=ifday;
    selection_parms.MOL_thresh_left=molleft;
    selection_parms.MOL_thresh_right=molright;
    selection_parms.HF08_inside=HF08_inside;
    
    canopy_parms.Scc=Scc;
    model_parms.beta1=beta1;
    canopy_parms.betan=betan_;
    model_parms.sw_over_ust=sw_ust;
 
end

 
cnames=measure_parms.cnames;
unames=measure_parms.unames;
zmast=measure_parms.zmast;
Lev_up=measure_parms.Lev_up;
dz=model_parms.dz;
bottom=model_parms.bottom;
hcanopy=canopy_parms.hcanopy;

%datafile='seNor_varsDlData.dat';
datafile='Smeardataexport20040501.csv'
dummyfc=9999;dummymol=9999;dummypar=-9999;dummysigw=9999;dummyco2=-9999;dummyust=9999;dummyrain=-9999;

% This was for Norunda station:
% [parin,C{1}]=get_series(path_to_data,'measured_global_par_longwave',datafile,'PAR IN');
% [mol,C{2}]=get_series(path_to_data,'measured_MOL_SHF_LHF_CO2flux_other',datafile,'L');
% [rain,C{3}]=get_series(path_to_data,'measured_CO2_meteo',datafile,'Rain');

% this is for Finnish (SMEAR):
% [parin,C{1}]=get_series(path_to_data,'radiations',datafile,'PAR');
% [mol,C{2}]=get_series(path_to_data,'fluxes',datafile,'MOL');
% [rain,C{3}]=get_series(path_to_data,'meteo',datafile,'Rain180');
if selection_parms.user~=true
% this is for Finnish (SMEAR):
   mol(find(isnan(mol) == 1))=dummymol;
   parin(find(isnan(parin) == 1))=dummypar;
   rain(find(isnan(rain) == 1))=dummyrain;
   dates=C{1};
  [maxcount]=cmpdates(C);
  C=[];
end
if selection_parms.day 
    parin=1;
else
    parin=-1;
end
mol=meteo_parms.MOL;
rain=0;
dates=meteo_parms.date';
[zgrid]=create_grid(zmast,Lev_up,dz,bottom);
index=[];
if selection_parms.user~=true
 [count,index]=count_valid(dates,parin,mol,rain,dummymol,dummypar,maxcount,selection_parms);
 dates1=dates(index,:); dates=dates1;dates1=[];
 names{1}=cnames;names{2}=unames;
 [variables]=get_variables(path_to_data,datafile,index,names,Lev_up,model_parms,canopy_parms);
 sz=size(variables,2);
%[dates,fc,sigw,ustar,co2,wspd,ta,mol]=check_dates_update_vars(dates,variables);variables=[];
 [dates,fc,sigw,ustar,co2,wspd,ta,mol,velo,tsoil]=check_dates_update_vars(dates,variables);variables=[];
else
    fc=canopy_parms.NEE;
    mol=meteo_parms.MOL;
    
    beta=canopy_parms.betan/fim_stab(canopy_parms.dsp,mol);% correction for beta dependance on stability
    [wspd,err]=uh_from_ur(zgrid,canopy_parms,meteo_parms.uref,mol,beta);

    ustar=beta*wspd;
    co2(1:Lev_up)=meteo_parms.co2ref;
    sigw=model_parms.sw_over_ust*ustar;
    velo(1:Lev_up)=wspd;
    ta=meteo_parms.ta;
    tsoil=meteo_parms.tsoil;
    %ustar=
end

[Sfric]=initialize_Sfric_new(2,canopy_parms,zgrid);


% perform integrations for different times
mae(1:Lev_up)=0;bias(1:Lev_up)=0;
allmae=0;
count=0;
c2avr=0;
betavr=0;
sigw2ustavr=0;
%ww=0;
konz=[];
kmonz=[];
nonvalid_corrections=0;
numerr=0;totcount=0;
dco2dtmeasabs=zeros(1,Lev_up);
c14avrfull=zeros(1,size(zgrid,2));
co2avrfull=zeros(1,size(zgrid,2));

for i=1:size(dates,1)

 %   if dates(i,1) >= last_year
 %       continue;
 %   end
    
    
    
    co2neighbabsent=false;
    strflux=0;
    dco2dt=zeros(1,size(zgrid,2));
    dco2dtmeas=zeros(1,Lev_up);
    %strflux=0;
    
    if co2neighbabsent
        continue;
    end
    dco2dtmeasabs=dco2dtmeasabs+abs(dco2dtmeas);
    
    co2absent=false;
    for j=1:Lev_up
        if co2(i,j)==dummyco2
            co2absent=true;break;
        end
    end
    veloabsent=false;
    for j=1:Lev_up
        if velo(i,j)<0
            veloabsent=true;break;
        end
    end
    if fc(i,1)==dummyfc || ustar(i,1)==dummyust || sigw(i,1)==dummysigw ||...
             co2absent || wspd(i,1)<0 || ta(i,1)==dummyco2  || mol(i,1)==dummymol ...
             || veloabsent || co2neighbabsent
        continue;
    end
    % additional QC checks
    if ustar(i,1)<selection_parms.thresh_ust
        continue;
    end
    if ustar(i,1)/wspd(i,1)<0.21 || ustar(i,1)/wspd(i,1)>0.4
        continue;
    end
    
    
    fc_strcor=fc(i,1)+strflux;

    if selection_parms.day==true
        if fc(i,1) > -selection_parms.absthresh_fc % only significant and 'correct' in direction fluxes are considered
        %if fc_strcor > -selection_parms.absthresh_fc % only significant and 'correct' in direction fluxes are considered
            continue;
        end
    else
        if fc(i,1) < selection_parms.absthresh_fc
        %if fc_strcor < selection_parms.absthresh_fc
            continue;
        end
    end
    beta=ustar(i,1)/wspd(i,1);

    if 2*beta-model_parms.carman*canopy_parms.Scc < 0
        continue;
    end
    
    if selection_parms.use_turb_meas==false
        betan=canopy_parms.betan;
%        if mol(i,1)>0
            beta=betan/fim_stab(canopy_parms.dsp,mol(i,1));% correction for beta dependance on stability
%        end
    end
   
    
    
    
    %canopy_parms.Scc=Sc_on_MOL(mol(i,1));
    
    if selection_parms.respiration==false % respiration is not considered separately. Only net fluxes are considered
        parts=partitioning(zgrid,src_parms.heights,src_parms.parts);  
        [fluxes]=prof_flux(zgrid,fc_strcor,parts);
        p_fluxes=[];
    else
        %rflux=1.64*exp(0.097*ta(i,1));% Norunda case according to Fig. 5 from [Lindroth, et.al., 1998] recalculated to micromols/m2/s
        rflux=net_resp*10^6/12/(365*24*3600);%0.25*tsoil(i,1)+0.27*(exp(0.14*ta(i,1)));%umol/m2s, for Finnish (SMEAR) site from Markkanen etal, 2001, Boreal Env. Res.
        
        p_parts=partitioning_photo(zgrid);
        [p_fluxes]=prof_flux(zgrid,fc_strcor-rflux,p_parts);% photosynthesis fluxes obtained from net flux (fc) and respiration flux

         r_parts=partitioning(zgrid,src_parms.resp_heights,src_parms.resp_parts);
        [r_fluxes]=prof_flux(zgrid,rflux,r_parts);% respiration fluxes obtained from net respiration flux partitioning setup by user
        
        fluxes=p_fluxes+r_fluxes;

    end
    fluxes=fluxes*(22.4/1000);% convert to 'mol*m/mol/s)'

    %   ww=ww+avg_w(i,1);


    
    totcount=totcount+1
    if totcount==400
        break;%temporary
    end

    sw_over_ust=sigw(i,1)/ustar(i,1);
    
    if selection_parms.use_turb_meas==false
        sw_over_ust=model_parms.sw_over_ust;%todel
    else
        model_parms.sw_over_ust=sw_over_ust;%todel
    end
    

    Lc=1/canopy_parms.Leaf_Vol/canopy_parms.Cd;

    if selection_parms.Scc_model
        canopy_parms.Scc= canopy_parms.Scc_neutr + canopy_parms.Scc_grad*tanh(2*Lc/mol(i,1));
        %use only when optimize Scc
            %canopy_parms.Scc= Scc_neutr + Scc_grad*tanh(2*Lc/mol(i,1));
    end

    c2_Tlscale=2*(beta^3)*Lc/sw_over_ust^2/hcanopy/canopy_parms.Scc;
    %c2_Tlscale=model_parms.c2_Tlscale;
    model_parms.c2_Tlscale=c2_Tlscale;

    %    [sigwz]=prof_sigw_raupach88(hcanopy,ustar(i,1),sigw(i,1),zgrid,model_parms.beta1);
    ustr=wspd(i,1)*beta;
    ustr=ustar(i,1);
    sgwh=sw_over_ust*wspd(i,1)*beta;
    
    [sigwz]=prof_sigw_raupach88(hcanopy,ustr,...
        sgwh,zgrid,model_parms.beta1);
    
    srcdist=sourcedistrib(zgrid,fluxes);

    %    [tlscale]=prof_tl_Haverd(hcanopy,ustar(i,1),zgrid,model_parms.c1_Tlscale,c2_Tlscale,canopy_parms,sigwz,mol(i,1));
    [tlscale]=prof_tl_Haverd(hcanopy,ustr,zgrid,model_parms.c1_Tlscale,c2_Tlscale,canopy_parms,sigwz,mol(i,1));
    
    if tlscale(1)<=0.0000001
        count=count-1;
        nonvalid_corrections=nonvalid_corrections+1;
        pause;
        continue;
    end
        
    %tlscale(1:size(zgrid,2))=0.35;
    %plot(tlscale*ustar(i,1)/hcanopy,zgrid/hcanopy)
    km_on_z=[];veloc=[];
    [veloc,km_on_z,err]=integr_velo(zgrid,canopy_parms,ustr,mol(i,1),selection_parms,...
        tlscale,sigwz,Sfric,beta);
    if err
        numerr=numerr+1;
        continue;
    end
    
   if selection_parms.cfaron==true
       c14=zeros(1,size(zgrid,2));
       if selection_parms.ifc14
        [cfar,k_on_z,c14]=integr2_cfar_c14(zgrid,tlscale,sigwz,fluxes,co2(i,Lev_up),...
            canopy_parms,ustr,mol(i,1),selection_parms,c14_parms,p_fluxes,beta,km_on_z,dco2dt);
        c14avrfull=c14avrfull+c14;
        co2avrfull=co2avrfull+cfar;
       else
        [cfar,k_on_z]=integr2_cfar_c14(zgrid,tlscale,sigwz,fluxes,co2(i,Lev_up),...
            canopy_parms,ustr,mol(i,1),selection_parms,c14_parms,p_fluxes,beta,km_on_z,dco2dt);
       end
    else
        cfar(1:size(zgrid,2))=co2(i,Lev_up);
   end
   
   count=count+1;
    betavr=betavr+beta;

    fluxc(count)=fc(i,1)*(22.4/1000); % convert to molar
    strfluxc(count)=strflux*(22.4/1000);
    %fluxc(count)=fc_strcor*(22.4/1000); % convert to molar
    betac(count)=ustar(i,1)/wspd(i,1);
    ust(count)=ustar(i,1);
    mol_x(count)=mol(i,1);
    sigw2ustavr=sigw2ustavr+sw_over_ust;
    c2avr=c2avr+c2_Tlscale;

   
   %plot_model_vs_meas(zgrid,cfar,zmast(1:Lev_up),co2(i,1:Lev_up))
    %plot(k_on_z.k,k_on_z.z);

    if size(konz,1)==0
        konz.z=k_on_z.z;konz.k=k_on_z.k/ust(count)/hcanopy;
        kmonz.z=km_on_z.z;kmonz.k=km_on_z.k/ust(count)/hcanopy;
    else
        konz.k=konz.k+k_on_z.k/ust(count)/hcanopy;
        kmonz.k=kmonz.k+km_on_z.k/ust(count)/hcanopy;
    end
    
    
    if selection_parms.cnearon==true
        [cnear]=integr_cnear(zgrid,tlscale,sigwz,fluxes,1.3*hcanopy);
    else
        cnear(1:size(zgrid,2))=0;
    end
    cfar_interp=interp1(zgrid,cfar,zmast(1:Lev_up));
    cnear_interp=interp1(zgrid,cnear,zmast(1:Lev_up));
    c14_interp=interp1(zgrid,c14,zmast(1:Lev_up));

    veloc_interp=interp1(zgrid,veloc,zmast(1:Lev_up));

    csum=cfar_interp+cnear_interp;
    
    if isnan(csum)==true
        'isnan(csum)==true'
        pause;
    end
    
    dc=csum-co2(i,1:Lev_up);
    mae=mae+abs(dc);
    allmae=allmae+sum(abs(dc));
    bias=bias+dc;
    %mae/count;
    %bias/count;

    % save results for every processed time step
    cmodel(1:size(csum,2),count)=csum;
    cobs(1:size(csum,2),count)=co2(i,:);
    c14all(1:size(csum,2),count)=c14_interp;
    
    sizei=size(veloc_interp,2);
    vobs(1:sizei,count)=velo(i,:);

    sizei=size(veloc_interp,2);
    vmodel(1:sizei,count)=veloc_interp;
    vobs(1:sizei,count)=velo(i,:);

    zndim(1:Lev_up,count)=zmast(1:Lev_up)/mol(i,1);
    
    %
    %break;

    if count > 0
       %break;
    end
    continue;
end
%konz.k=konz.k/count;
stat_errors.mae=mae/count;
stat_errors.bias=bias/count;
stat_errors.count=count;
c2avr=c2avr/count;
betavr=betavr/count;
sigw2ustavr=sigw2ustavr/count;
dco2dtmeasabs=dco2dtmeasabs/count;
c14avrfull=c14avrfull/count;
co2avrfull=co2avrfull/count;
allmae=allmae/count;
%ww/count;
[vmodel_nondim_avr,vobs_nondim_avr,vleft_nondim,vright_nondim,intervals,...
    vleft_nondim_model,vright_nondim_model]=...
    process_vprofiles(vmodel,vobs,ust);

co2=[];
[cmodel_nondim_avr,cobs_nondim_avr,cleft_nondim,cright_nondim,intervals,cleft_nondim_model,cright_nondim_model]=...
    process_profiles(cmodel,cobs,fluxc,ust);
%[cmodel_nondim_avr,cobs_nondim_avr,cleft_nondim,cright_nondim,...
%    intervals,cleft_nondim_model,cright_nondim_model,intervalm,nrec]=...
%    process_profiles2(cmodel,cobs,fluxc,ust,mol_x,-250,-70);

[c14avr]=process_c14(c14all);
[cobsavr]=process_c14(cobs);
%IK2019 c14avr=c14avr*(1000/24/c14_parms.Bq2micromol); % convert from micromol/mol
%IK2019 c14avrfull=c14avrfull*(1000/24/c14_parms.Bq2micromol); % convert from micromol/mol
%to Bq/m3
%c14rel=c14avr/(co2(1)*(1000/24/1000000)*(12/1000));
for i=1:size(c14avr)
    c14rel(i,1)=c14avr(i,1)/(cobsavr(i,1)*(1000/22.4)*0.000001*0.012);%Bq/kgC taking into account that cobsavr is CO2
end
for i=1:size(c14avrfull,2)
    c14relfull(i)=c14avrfull(i)/(co2avrfull(i)*(1000/22.4)*0.000001*0.012);%Bq/kgC taking into account that cobsavr is CO2
end
figure
plot(c14relfull',zgrid');
title('C14relfull (Bq kg C-1)');
xlabel('C14relfull (Bq kg C-1)');
ylabel('z');
figure
plot(c14avrfull',zgrid');
title('C14avrfull (Bq m-3)');
xlabel('C14avrfull (Bq m-3)');
ylabel('z');
AAA=zeros(size(zgrid,2),3);
AAA(:,1)=zgrid;AAA(:,2)=c14relfull';AAA(:,3)=c14avrfull';
format long
%xlswrite('AAA.xls',AAA,strcat(num2str(meteo_parms.uref),'ms'));
xlswrite(strcat(output_filename,'.xls'),c14relfull','C14relfull (Bq kg C-1)');
xlswrite(strcat(output_filename,'.xls'),c14avrfull','C14avrfull (Bq m-3)');
xlswrite(strcat(output_filename,'.xls'),zgrid','zgrid');

%sum(c14relfull(365:494))/(494-365+1) % average conc in canopy layer
%figure
%plot_handle1=plot(vobs_nondim_avr,zmast(1:Lev_up)',vmodel_nondim_avr,zmast(1:Lev_up)',...
 %   vleft_nondim,zmast(1:Lev_up)',vright_nondim,zmast(1:Lev_up)');
%figure
%plot_handle=plot(cobs_nondim_avr,zmast(1:Lev_up)',cmodel_nondim_avr,zmast(1:Lev_up)',...
 %   cleft_nondim,zmast(1:Lev_up)',cright_nondim,zmast(1:Lev_up)');


%plot_handle=plot(konz.k,konz.z);
save('all.mat');
results.cobs_nondim_avr=cobs_nondim_avr;
results.cleft_nondim=cleft_nondim;
results.cright_nondim=cright_nondim;
results.cmodel_nondim_avr=cmodel_nondim_avr;
results.cleft_nondim_model=cleft_nondim_model;
results.cright_nondim_model=cright_nondim_model;

%save(outname,'results','zmast','Lev_up',...
%'stat_errors','canopy_parms','model_parms','src_parms','selection_parms');
% old save
%save(outname,'cobs_nondim_avr','cleft_nondim','cright_nondim','cleft_nondim','intervals','zmast','Lev_up',...
%'stat_errors','canopy_parms','model_parms','src_parms','selection_parms');
if nestedrun
    results1(1:Lev_up,1)=zmast(1:Lev_up)';
    results1(1:Lev_up,2)=cobs_nondim_avr;
    results1(1:Lev_up,3)=cmodel_nondim_avr;
    outdir=strcat('./',runname);
    mkdir(outdir);
    xlsname=strcat(outdir,'/',runname,'.xls');
    xlswrite(xlsname,results1);
    matname=strcat(outdir,'/mat.mat');
    save(matname);
    figname=strcat(outdir,'/Fig.jpg');
    saveas(gcf,figname,'jpg');
end
return;
end


function [variables]=get_variables(path_to_data,datafile,index,names,Lev_up,model_parms,canopy_parms)
cnames=names{1};
unames=names{2};
[fc,dates2]=get_series(path_to_data,'fluxes',datafile,'F_c',index);
variables{1}.name='fc';variables{1}.var=fc;variables{1}.dates=dates2;
[sigw,dates3]=get_series(path_to_data,'fluxes',datafile,'UST',index);
sigw=model_parms.sw_over_ust*sigw;% this is quasi-measurement; ustar is multiplied on constant
variables{2}.name='sigw';variables{2}.var=sigw;variables{2}.dates=dates3;

[ustar,dates4]=get_series(path_to_data,'fluxes',datafile,'UST',index);
variables{3}.name='ustar';variables{3}.var=ustar;variables{3}.dates=dates4;

[co2_,dates5]=get_series(path_to_data,'c_6levs',datafile,cnames{1},index);
%[avg_w,dates4]=get_series(path_to_data,'measured_MOL_SHF_LHF_CO2flux_other',datafile,'avg_w',index);
co2=co2_;
for i=2:Lev_up
    [co2_]=get_series(path_to_data,'c_6levs',datafile,cnames{i},index);
    co2(:,i)=co2_;
end
co2_=[];

variables{4}.name='co2';variables{4}.var=co2;variables{4}.dates=dates5;


[u4,dates6]=get_series(path_to_data,'meteo',datafile,'U084',index);
[u5,dates6]=get_series(path_to_data,'meteo',datafile,'U168',index);
%wspd=0.5*(u4+u5);
hcanopy=canopy_parms.hcanopy;
wspd=((16.8-hcanopy)*u4+(hcanopy-8.4)*u5)/(16.8-8.4);% interpolation to canopy height
variables{5}.name='wspd';variables{5}.var=wspd;variables{5}.dates=dates6;
[ta]=get_series(path_to_data,'meteo',datafile,'T84',index);
variables{6}.name='ta';variables{6}.var=ta;variables{6}.dates=dates5;
[mol]=get_series(path_to_data,'fluxes',datafile,'MOL',index);
variables{7}.name='mol';variables{7}.var=mol;variables{7}.dates=dates2;

%unames{1}='U084';unames{2}='U168';unames{3}='U336';unames{4}='U672';
[velo_]=get_series(path_to_data,'meteo',datafile,unames{2},index);
velo=velo_;
velo(:,2)=velo_;velo(:,1)=0;%at smear velo is not available at 1st lev (4.2 m)
%for i=2:Lev_up
for i=3:Lev_up
    if i==Lev_up
        velo(:,i)=0;% at Lev_up no measurements at SMEAR
        break;
    end
    if i==5
        unames{i}='U672';% u504 is not available but u672 is available
    end
    [velo_]=get_series(path_to_data,'meteo',datafile,unames{i},index);
    velo(:,i)=velo_;
    if i==5
        velo(:,i)=((67.2-50.4)*velo(:,i-1)+(50.4-33.6)*velo_)/(67.2-33.6);
    end
end
velo_=[];
variables{8}.name='velo';variables{8}.var=velo;variables{8}.dates=dates6;

[tsoil,dates7]=get_series(path_to_data,'soil',datafile,'SOILT',index);
variables{9}.name='soilt';variables{9}.var=tsoil;variables{9}.dates=dates7;
return;
end

function  [maxcount]=cmpdates(C)
% compares dates contained in cell array C
for i=1:size(C{1},1)
    dateprev=datenum(C{1}(i,1),C{1}(i,2),C{1}(i,3),C{1}(i,4),C{1}(i,5),C{1}(i,6));
    for j=2:size(C,2)
        datej=datenum(C{j}(i,1),C{j}(i,2),C{j}(i,3),C{j}(i,4),C{j}(i,5),C{j}(i,6));
        if datej~=dateprev
            maxcount=i;
            return;
        end
        dateprev=datej;
    end
end
maxcount=size(C{1},1);
return;
end