function [parts_grid]=partitioning(zgrid,heights,parts);
% defines partitioning of total flux through canopy on heights

if size(heights,2)~=size(parts,2)
    'size(heights,2)~=size(parts,2)'
    pause;
end
if abs(sum(parts)-1)>0.01
    'partitioning is incorrect: sum(parts)~=1'
    pause;
end

l=1;
maxsize=size(zgrid,2);
start=maxsize;
for i=maxsize:-1:1
    if zgrid(i)>= heights(l)
        parts_grid(i:start)=parts(l)/(start-i+1);
        l=l+1;
        start=i-1;
        if l>size(heights,2) && i>1
            parts_grid(start:1)=0;
            break;
        end
    end
end

if abs(sum(parts_grid)-1)>0.01
    'warning: sum of resulting parts is not equal to 1'
    pause;
end
return;
end