function  [cmodel_nondim_avr,cobs_nondim_avr,cleft_nondim,cright_nondim,interval,cleft_nondim_model,cright_nondim_model,intervalm,nrec]=...
    process_profiles2(cmodel,cobs,fluxc,ust,mol_x,Lmin,Lmax)
% makes profiles nondimensional, extracts reference concentration,
% calculates intervals of 'uncertainty'

ntot=size(cmodel,2);
nlevs=size(cmodel,1);

nrec=0;
for i=1:ntot
    if mol_x(i)>Lmax || mol_x(i)<Lmin
        continue;
    end
    nrec=nrec+1;
end

cmodel_nondim=zeros(nlevs,nrec);
cobs_nondim=zeros(nlevs,nrec);
cmodel_nondim_avr=zeros(nlevs,1);
cobs_nondim_avr=zeros(nlevs,1);

i=0;
for ii=1:ntot
    if mol_x(ii)>Lmax || mol_x(ii)<Lmin
        continue;
    end
    i=i+1;
    for j=1:nlevs
         cmodel_nondim(j,i)=(cmodel(j,i)-cobs(nlevs,i))*ust(i)/abs(fluxc(i));
         cobs_nondim(j,i)=(cobs(j,i)-cobs(nlevs,i))*ust(i)/abs(fluxc(i));
         cmodel_nondim_avr(j,1)=cmodel_nondim_avr(j,1)+cmodel_nondim(j,i);
         cobs_nondim_avr(j,1)=cobs_nondim_avr(j,1)+cobs_nondim(j,i);
        if j==1 && cmodel_nondim_avr(j,1)/i > 1000
            
            j=1;
        end

    end
end

cmodel_nondim_avr=cmodel_nondim_avr/nrec;
cobs_nondim_avr=cobs_nondim_avr/nrec;

cdiff=zeros(nrec,nlevs);

for j=1:nlevs
    for i=1:nrec
        cdiff(i,j)=abs(cobs_nondim(j,i)-cobs_nondim_avr(j,1));
        cdiff2(i,j)=cobs_nondim(j,i)-cobs_nondim_avr(j,1);
        cdiffm(i,j)=abs(cmodel_nondim(j,i)-cmodel_nondim_avr(j,1));
        cdiffm2(i,j)=cmodel_nondim(j,i)-cmodel_nondim_avr(j,1);
    end
end

abscriteria=false;
for j=1:nlevs
    if j==nlevs
        j=nlevs;
    end
    if abscriteria
        cextract=cdiff(:,j);
        cdiffsort=sort(cextract,1);
        interval(j,1)=0.5*cdiffsort(floor(0.9*nrec),1);
        cright_nondim(j,1)=cobs_nondim_avr(j,1)+interval(j,1);
        cleft_nondim(j,1)=cobs_nondim_avr(j,1)-interval(j,1);
    else
        ngt0=0;
        nlt0=0;
        cgt0=[];
        clt0=[];
        for i=1:nrec
            if cobs_nondim(j,i)-cobs_nondim_avr(j,1) > 0
                ngt0=ngt0+1;
                cgt0(ngt0,1)=cdiff2(i,j);
            end
            if cobs_nondim(j,i)-cobs_nondim_avr(j,1) < 0
                nlt0=nlt0+1;
                clt0(nlt0,1)=-cdiff2(i,j);
            end
        end
        
        if ngt0<=1
            cright_nondim(j,1)=cobs_nondim_avr(j,1);
        else
            cdiffsort=sort(cgt0,1);
            cright_nondim(j,1)=cobs_nondim_avr(j,1)+cdiffsort(floor(0.5*size(cgt0,1)),1);
        end
        if nlt0<=1
            cleft_nondim(j,1)=cobs_nondim_avr(j,1);
        else
            cdiffsort=sort(clt0,1);
            cleft_nondim(j,1)=cobs_nondim_avr(j,1)-cdiffsort(floor(0.5*size(clt0,1)),1);
        end
        interval=[];

    end
end


if nargout <=5
    cright_nondim_model=[];
    cleft_nondim_model=[];
    intervalm=[];
    return;
end
    % calculated left and righ boundaries also for model
    
for j=1:nlevs
    if abscriteria
        cextract=cdiffm(:,j);
        cdiffsort=sort(cextract,1);
        intervalm(j,1)=0.5*cdiffsort(floor(0.9*nrec),1);
        cright_nondim_model(j,1)=cmodel_nondim_avr(j,1)+intervalm(j,1);
        cleft_nondim_model(j,1)=cmodel_nondim_avr(j,1)-intervalm(j,1);
    else
        ngt0=0;
        nlt0=0;
        cgt0=[];
        clt0=[];
        for i=1:nrec
            if cmodel_nondim(j,i)-cmodel_nondim_avr(j,1) > 0
                ngt0=ngt0+1;
                cgt0(ngt0,1)=cdiffm2(i,j);
            end
            if cmodel_nondim(j,i)-cmodel_nondim_avr(j,1) < 0
                nlt0=nlt0+1;
                clt0(nlt0,1)=-cdiffm2(i,j);
            end
        end
        
        if ngt0<=1
            cright_nondim_model(j,1)=cmodel_nondim_avr(j,1);
        else
            cdiffsort=sort(cgt0,1);
            cright_nondim_model(j,1)=cmodel_nondim_avr(j,1)+cdiffsort(floor(0.5*size(cgt0,1)),1);
        end
        
        if nlt0<=1
            cleft_nondim_model(j,1)=cmodel_nondim_avr(j,1);
        else
            cdiffsort=sort(clt0,1);
            cleft_nondim_model(j,1)=cmodel_nondim_avr(j,1)-cdiffsort(floor(0.5*size(clt0,1)),1);
        end
        intervalm=[];

    end
end
return;


