function  [vmodel_nondim_avr,vobs_nondim_avr,vleft_nondim,vright_nondim,interval,...
    vleft_nondim_model,vright_nondim_model,intervalm]=...
    process_vprofiles(vmodel,vobs,ust)
% makes profiles nondimensional, extracts reference concentration,
% calculates intervals of 'uncertainty'

ntot=size(vmodel,2);
nlevs=size(vmodel,1);

vmodel_nondim=zeros(nlevs,ntot);
vobs_nondim=zeros(nlevs,ntot);
vmodel_nondim_avr=zeros(nlevs,1);
vobs_nondim_avr=zeros(nlevs,1);

for i=1:ntot
    for j=1:nlevs
         vmodel_nondim(j,i)=vmodel(j,i)/ust(i);
         vobs_nondim(j,i)=vobs(j,i)/ust(i);
         vmodel_nondim_avr(j,1)=vmodel_nondim_avr(j,1)+vmodel_nondim(j,i);
         vobs_nondim_avr(j,1)=vobs_nondim_avr(j,1)+vobs_nondim(j,i);
    end
end

vmodel_nondim_avr=vmodel_nondim_avr/ntot;
vobs_nondim_avr=vobs_nondim_avr/ntot;

vdiff=zeros(ntot,nlevs);

for j=1:nlevs
    for i=1:ntot
        vdiff(i,j)=abs(vobs_nondim(j,i)-vobs_nondim_avr(j,1));
        vdiff2(i,j)=vobs_nondim(j,i)-vobs_nondim_avr(j,1);
        vdiffm(i,j)=abs(vmodel_nondim(j,i)-vmodel_nondim_avr(j,1));
        vdiffm2(i,j)=vmodel_nondim(j,i)-vmodel_nondim_avr(j,1);
    end
end

abscriteria=false;
for j=1:nlevs
    if j==nlevs
        j=nlevs;
    end
    if abscriteria
        vextract=vdiff(:,j);
        vdiffsort=sort(vextract,1);
        interval(j,1)=0.5*vdiffsort(floor(0.5*ntot),1);
        vright_nondim(j,1)=vobs_nondim_avr(j,1)+interval(j,1);
        vleft_nondim(j,1)=vobs_nondim_avr(j,1)-interval(j,1);
    else
        ngt0=0;
        nlt0=0;
        vgt0=[];
        vlt0=[];
        for i=1:ntot
            if vobs_nondim(j,i)-vobs_nondim_avr(j,1) > 0
                ngt0=ngt0+1;
                vgt0(ngt0,1)=vdiff2(i,j);
            end
            if vobs_nondim(j,i)-vobs_nondim_avr(j,1) < 0
                nlt0=nlt0+1;
                vlt0(nlt0,1)=-vdiff2(i,j);
            end
        end
        
        if ngt0<=1
            vright_nondim(j,1)=vobs_nondim_avr(j,1);
        else
            vdiffsort=sort(vgt0,1);
            vright_nondim(j,1)=vobs_nondim_avr(j,1)+vdiffsort(floor(0.5*size(vgt0,1)),1);
        end
        if nlt0<=1
            vleft_nondim(j,1)=vobs_nondim_avr(j,1);
        else
            vdiffsort=sort(vlt0,1);
            vleft_nondim(j,1)=vobs_nondim_avr(j,1)-vdiffsort(floor(0.5*size(vlt0,1)),1);
        end
        interval=[];

    end
end


if nargout <=5
    vright_nondim_model=[];
    vleft_nondim_model=[];
    intervalm=[];
    return;
end
    % calculated left and righ boundaries also for model
    
for j=1:nlevs
    if abscriteria
        vextract=vdiffm(:,j);
        vdiffsort=sort(vextract,1);
        intervalm(j,1)=0.5*vdiffsort(floor(0.5*ntot),1);
        vright_nondim_model(j,1)=vmodel_nondim_avr(j,1)+intervalm(j,1);
        vleft_nondim_model(j,1)=vmodel_nondim_avr(j,1)-intervalm(j,1);
    else
        ngt0=0;
        nlt0=0;
        vgt0=[];
        vlt0=[];
        for i=1:ntot
            if vmodel_nondim(j,i)-vmodel_nondim_avr(j,1) > 0
                ngt0=ngt0+1;
                vgt0(ngt0,1)=vdiffm2(i,j);
            end
            if vmodel_nondim(j,i)-vmodel_nondim_avr(j,1) < 0
                nlt0=nlt0+1;
                vlt0(nlt0,1)=-vdiffm2(i,j);
            end
        end
        
        if ngt0<=1
            vright_nondim_model(j,1)=vmodel_nondim_avr(j,1);
        else
            vdiffsort=sort(vgt0,1);
            vright_nondim_model(j,1)=vmodel_nondim_avr(j,1)+vdiffsort(floor(0.5*size(vgt0,1)),1);
        end
        
        if nlt0<=1
            vleft_nondim_model(j,1)=vmodel_nondim_avr(j,1);
        else
            vdiffsort=sort(vlt0,1);
            vleft_nondim_model(j,1)=vmodel_nondim_avr(j,1)-vdiffsort(floor(0.5*size(vlt0,1)),1);
        end
        intervalm=[];

    end
end
return;


