function [tlscale]=prof_tl_Haverd(hcanopy,ust,zgrid,c1,c2,canopy_parms,sigw,mol)
% sets Lagrangian time scale accordin to relation by Haverd, et.al., 2009.
% Boundary Layer Meteo. Above canopy constant value is used. 

betan=canopy_parms.betan;
Scc=canopy_parms.Scc;
St=canopy_parms.St;
Leaf_Vol=canopy_parms.Leaf_Vol;
Cd=canopy_parms.Cd;

if mol>0
    beta=betan/fim_stab(canopy_parms.dsp,mol);% correction for beta dependance on stability
else
    beta=betan;
end

for i=size(zgrid,2):-1:1
    if zgrid(i)>hcanopy
        [Kc]=Kc_above_canopy_HF2008(zgrid(i),hcanopy,ust,beta,Scc,St,Leaf_Vol,Cd,mol);
        tlscale(i)=Kc/sigw(i)^2;
        continue;
    end
   %if zgrid(i)>hcanopy & zgrid(i)<1.25*hcanopy
   %     tlscale(i)=tlscale(i+1);
   %     continue;
   % elseif zgrid(i)>=1.5*hcanopy
   %     tlscale(i)=(hcanopy/ust)*0.4*(zgrid(i)-0.75*hcanopy)/hcanopy/power(sigw(i)/ust,2);
   %     continue;
   % end
   
    tlscale(i)=(hcanopy/ust)*c2*(1-exp(-c1*zgrid(i)/hcanopy))/(1-exp(-c1));
end

return;
end