function [Uh,err]=uh_from_ur(zgrid,canopy_parms,uref,mol,beta)
% integrates velocity to obtain Uh from Uref, and other input parameters
%uref is assumed related to height at zgrid(1)
%Ref. Harman & Finnigan, 2008
carman=0.4;
hcanopy=canopy_parms.hcanopy;
Cd=canopy_parms.Cd; Leaf_Vol=canopy_parms.Leaf_Vol;
Lc=1/Leaf_Vol/Cd;
betan=canopy_parms.betan;

maxsz=size(zgrid,2);
%veloc=zeros(1,maxsz);
for i=1:maxsz
    if zgrid(i)<=hcanopy
        ilast=i;
        break;
    end
end
 
A=zeros(ilast,ilast);
bb=zeros(ilast,1);
xx=zeros(ilast,1);
A(1,1)=1;bb(1,1)=uref;

for i=2:ilast

    dz=zgrid(i-1)-zgrid(i);
    zi12=0.5*(zgrid(i)+zgrid(i-1));
    if i==214
        bbb=0;
    end

    [kdif,err,d,fim,fim1]=Km_above_canopy_HF2008(zi12,hcanopy,1.,beta,Leaf_Vol,Cd,mol);
    %Km=carman*ustar*(z-d)/fim1/fim;
    
    if err
        veloc=[];k_on_z=[];
        return;
    end
    
    if kdif < 0
        'kdif < 0; i='
        i
        pause;
    end
    A(i,i-1)=carman*(zi12-d)/fim/fim1/dz;
    A(i,i)=-carman*(zi12-d)/fim/fim1/dz;
    A(i,ilast)=A(i,ilast)-beta;%for the last node A(i,i)=A(i,ilast)
    %veloc(i)=veloc(i+1)+dz*(ust^2)/kdif;
 end
% integrating inside canopy
xx=A\bb;
Uh=xx(ilast);

return;
end