% designed to solve momentum equation d(KdU/dz)/dz by Newton method - @newtonsys
% subroutine
function [res]=uprofile_newton(x,flag,ust,uref,zz,kdif,Sfr,z0)
carman=0.4;
Nz=size(x,1);

if isempty(flag)
    flag='';
end

switch lower(flag)
case ''
    res=zeros(Nz,1);
    res(1,1)=x(1,1)-uref;
    
    dz=zz(1)-zz(2);
    kk1=2*kdif(1)*kdif(2)/(kdif(1)+kdif(2));
    res(2,1)=kk1*(x(1,1)-x(2,1))/dz - ust^2;
    
    for i=3:Nz-1
        
        dz1=zz(i-1)-zz(i);
        dz2=zz(i)-zz(i+1);
        dz=0.5*(dz1+dz2);
        kk1=2*kdif(i-1)*kdif(i)/(kdif(i-1)+kdif(i));
        kk2=2*kdif(i+1)*kdif(i)/(kdif(i+1)+kdif(i));
        res(i,1)=(kk1/dz1/dz)*x(i-1,1)-(kk1/dz1/dz+kk2/dz2/dz)*x(i,1)+...
            (kk2/dz2/dz)*x(i+1,1)-Sfr(i)*x(i,1)^2;
    end
       mult=(carman/log(zz(Nz)/z0))^2;
       kk1=2*kdif(Nz-1)*kdif(Nz)/(kdif(Nz-1)+kdif(Nz));
       dz=zz(Nz-1)-zz(Nz);
       res(Nz,1)=(kk1/dz/dz)*x(Nz-1,1)-(kk1/dz/dz)*x(Nz,1) - ...
        (mult/dz)*x(Nz,1)^2;
    
    
case 'jacobian'
     res=sparse(zeros(Nz,Nz));
     res(1,1)=1;

    dz=zz(1)-zz(2);
    kk1=2*kdif(1)*kdif(2)/(kdif(1)+kdif(2));
    res(2,1)=kk1/dz ; res(2,2)=-kk1/dz ; %res(2,1)=kk1*(x(1,1)-x(2,1))/dz - ust^2;
    
     for i=3:Nz-1
        dz1=zz(i-1)-zz(i);
        dz2=zz(i)-zz(i+1);
        dz=0.5*(dz1+dz2);
        kk1=2*kdif(i-1)*kdif(i)/(kdif(i-1)+kdif(i));
        kk2=2*kdif(i+1)*kdif(i)/(kdif(i+1)+kdif(i));
        
        %res(i,1)=(kk1/dz1/dz)*x(i-1,1)-(kk1/dz1/dz+kk2/dz2/dz)*x(i,1)+(kk2/dz2/dz)*x(i+1,1)-Sfr(i)*x(i,1)^2;
        res(i,i-1)=(kk1/dz1/dz); res(i,i+1)=(kk2/dz2/dz);
        res(i,i)=-(kk1/dz1/dz+kk2/dz2/dz)-2*Sfr(i)*x(i,1);
     end

       mult=(carman/log((zz(Nz)-25*z0)/z0))^2;
       kk1=2*kdif(Nz-1)*kdif(Nz)/(kdif(Nz-1)+kdif(Nz));
       dz=zz(Nz-1)-zz(Nz);
       %res(Nz,1)=(kk1/dz/dz)*x(Nz-1,1)-(kk1/dz/dz)*x(Nz,1) -(mult/dz)*x(Nz,1)^2;
       res(Nz,Nz-1)=(kk1/dz/dz); 
       res(Nz,Nz)=-(kk1/dz/dz)-2*(mult/dz)*x(Nz,1);
     
end

end
